unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,unit2, ExtCtrls, ImgList, StdCtrls, Menus, ComCtrls;

const TerrainW=37; TerrainH=25; //Largeur et hauteur du terrain

      //Sprites du serpent et des fruits
      //le gros bitmap est dcompose en imagettes (sprites)
      //qu'on choisi d'indexer de 0  14
      S_HL=0;   S_HR=1;   S_HD=2;   S_HU=3;   //(H)ead ( (L)eft/(R)ight/(D)own/(U)p ) (tte)
      S_TR=4;   S_TL=5;   S_TU=6;   S_TD=7;   //(T)ail (queue)
      S_TLR=8;  S_TUD=9;  S_TRD=10; S_TLD=11; //(T)ail (anneaux) (2 connections pour chaque anneau
      S_TRU=12; S_TLU=13;                     //Left/Right , Up/Down, Right/Down, etc....
      S_M=14;                                 // (M)anger : index=14(+niveau du tableau donc : 14, 15, 16, 17, 18)
      S_G=112;                                //Du terrain sans serpent
                                              //pourquoi 112, parce que je vais placer mes
                                              //graphiques dans un tableau d'entiers
                                              //si la valeur de ma case est infrieure  100
                                              //j'irais piocher mon graphique dans le bitmap o se trouvent les "bouts de serpent"
                                              //sinon, j'irais chercher dans le bitmap o se trouvent l'herbe et les rochers
      //les rochers, l''herbe :
      //a se corse...
      //chaque sprite (lment de terrain) est divis en 4 zones :
      //- le coin en haut  gauche, celui du haut  droite, celui du bas  gauche et celui du bas  droite
      //Chaque coin peut tre "rocheux (ou herbeux)" ou
      //"sans rien (l o le serpent  le droit de se dplacer)",
      //1 ou 0, donc avec 4 coins, on a 4 bits
      //qui forment un entier de 0  15 (donc on a 16 types de terrain)
      //On a par exemple :
      //le terrain compltement
      //-"sans rien" : valeur 0-->sprite n12 (+100=112)
      //       terrain sur lequel notre serpent pourra se dplacer
      //- le terrain compltement herbeux : valeur 15, sprite n13 (on utilisera une fonction alatoire
      //       quand on tombera sur ce type de terrain pour afficher de temps en temps des paquerettes,
      //       qui correspondent au sprites n13, 14, 15, etc...
      //donc  gauche : la valeur de terrain ;  droite la correspondance avec le sprite dans le bitmap (+100)
      Rochers:Array[0..15] of byte=(112,102,100,110,101,117,108,107,103,109,117,105,111,104,106,113);

      //Bonus serpents  80000, 130000 et 150000
      Bonus1=80000;
      Bonus2=130000;
      Bonus3=150000;
type
  //Un score (on va en faire un tableau de dix comme a), c'est :
  //un nom, un score, et une ligne d'affichage
  TScore=record
    Nom:string[10];
    Score:integer;
    Affichage:string;
  end;
  //deux styles (faon vieux micro-ordinateur, ou faon toon dans le jardin
  //A chaque fois, il faudra envisager selon l'une ou l'autre valeur choisie par
  //l'utilisateur une routine d'affichage diffrente
  TStyle=(s8bits,sToon);
  //juste avant de dplacer le serpent, on testera son ventuelle case d'arrive
  //le serpent rencontrera t'il un rocher (ou de l'herbe), un bord de terrain,
  //un fruit, lui-mme, ou une case vide ?
  TRTest=(rRocher,rBord,rPomme,rSerpent,rRien);
  //a, c'est pour l'affichage,
  //soit on va boucler sur :
  //-Le tableau du High-Score
  //-La  1ere page d'instructions
  //-La 2me, la 3me, la 4me, et hop, retour au High-Score
  //Soit on sera en pleine partie (mode Jeu)
  TMode=(mHighScores,mInstructions1,mInstructions2,mInstructions3,mInstructions4,mJeu);

  TForm1 = class(TForm)
    //Menu
    MainMenu1: TMainMenu;
    Jeu1: TMenuItem;
    NouvellePartie1: TMenuItem;
    Quitter1: TMenuItem;
    Options1: TMenuItem;
    Style1: TMenuItem;
    N8bits1: TMenuItem;
    Toons1: TMenuItem;
     N1: TMenuItem;
    Joueurs1: TMenuItem;
    N1Joueur1: TMenuItem;
    N2Joueurs1: TMenuItem;
    N2: TMenuItem;
    ResetdesScores1: TMenuItem;
    Son1: TMenuItem;

    //Le timer qui sert  tout (animations)
    Timer1: TTimer;
    //Composants d'affichage pour le mode "Intro" (high-Scores/Instruction)
    PanelIntro: TPanel;
    PaintBoxIntro: TPaintBox;

    //Composants d'affichage pour le mode Jeu
    PaintBoxJeu: TPaintBox;  //Terrain de Jeu

    PanelJeu: TPanel; //Panneau de stats du jeu, qui comprend les compos suivants
    lblJ1: TLabel;    //affichage de "Joueur 1"
    LblJ2: TLabel;    //                     2
    lblV1: TLabel;    //affichage de  "Vies" (cot Joueur 1)
    LblV2: TLabel;    //idem cot Joueur 2
    LblTemps: TLabel; //affichage du mot "Temps"
    LblT: TLabel;     //Chrono du jeu
    lblPoints1: TLabel; //Nbre de points du Joueur 1
    LblVies1: TLabel;   //Nbre de vies  du Joueur 1
    lblPoints2: TLabel; //Nbre de points du Joueur 2
    LblVies2: TLabel;   //Nbre de vies  du Joueur 2




    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxJeuPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Toons1Click(Sender: TObject);
    procedure N8bits1Click(Sender: TObject);
    procedure NouvellePartie1Click(Sender: TObject);
    procedure PaintBoxIntroPaint(Sender: TObject);
    procedure ResetdesScores1Click(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure N2Joueurs1Click(Sender: TObject);
    procedure N1Joueur1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
    //a, c'est la grille "terrain" qui contient l'index des diffrents bitmaps du jeu
    //elle sera "calcule" en fonction de la grille "niveau" (alimente grace aux fichiers textes L1.txt, L2.txt, etc...)
    GrilleTerrain:array[0..TerrainW-1,0..TerrainH-1] of byte;
    GrilleNiveau:Array[0..TerrainW-1,0..TerrainH-1] of char;
    //si cette valeur est suprieure  0, le serpent s'allonge
    //Le but est de la dcrmenter de 1 chaque fois que le serpent se dplace et d'allonger  ce moment le serpent
    // et de l'incrmenter chaque fois que le vorace avale une pomme, un oeuf ou un champignon
    Allonge:byte;

    Affichage:TBitmap; //Bitmap qui servira  l'affichage du jeu, sera
                       //utilis par le onPaint du TPaintBoxJeu
    AffichageAccueil:TBitmap; //Bitmap, surlequel on dessine
                              //l'affichage de la page d'acceuil
                              //utilis par le onPaint du TPaintBoxIntro
    SpritesToonS:TBitmap; //les sprites "S"erpent (+fruits)
    SpritesToonT:TBitmap; //les sprites "T"errain
    Sprites8bits:TBitmap; //les sprites "8 bits"
    Serpent:TSerpent;  //le serpent du Jeu
    SerpentIntro:TSerpent; //le serpent qui tourne autour du mot Cobra

    DerniereToucheAppuyee:integer; //c'est clair non ?
                           //Chaque fois que l'utilisateur appuira sur une touche (OnKeyDown de la fiche)
                           //on enregistre la touche.
                           //Puis on rutilise cette touche dans la boucle de jeu dclenche par le timer
                           //(si on est en train de jouer. Comme a l'utilisateur  l'impression
                           //que le serpent  "une mmoire", et le serpent ne se dplace que quand on a envie qu'il le fasse
    DepartSerpent:Tpoint;  //important ! il faut placer le serpent sur le terrain au dbut de chaque niveau
                           //dans les fichiers textes L1.txt, L2.txt, etc..., c'est la lettre "S" (comme Start ou Serpent)
                           //qui nous fourni cette indication
    NiveauGrille:integer;  //Le joueur est  quel niveau ?

    FStyle: TStyle;        //Choix de theme de l'utilisateur
    Scores:array[0..10] of TScore; //Tableau des High-Score (l'lment numro 10)
                                   //permet de faire entrer un 11me, hro, on trie le tableau, on garde les 10 premiers, on jette le dernier
                                   //(c'est comme dans Highlander : il ne peut en rester que dix !)
    Instructions:TStringList; //Les instructions sont dans un fichier texte.
                              //mon truc est super mal fichu, a vaut ce que a vaut, mais a marche
    IntroTitre:string;        //selon qu'on affiche le High-Score, ou une page d'instruction, on ne met pas le mme titre
    IntroLignes:TStringList; //ce seront les lignes effectivement affiches  l'cran (scores, ou lignes d'instructions)
    Fmode: TMode;            //le mode d'affichage en cours
    //Mode<>Jeu
    modecounter:integer;     //Alors, donc on a un timer qui sert  "animer le serpent"
                             //et aprs admettons 20 dplacements de serpent, on changera
                             //l'affichage d'intro du High-score  la 1ere
                             //page d'instructions et ainsi de suite.
                             //donc on incrmente ce truc  chaque fois que le timer est dclench
                             // (OnTimer), et on change de mode quand ce truc est gal  20,40,60, etc...
    //Mode Jeu
    NbreJoueurs:byte;
    FNiveauJ:array[0..1] of integer; //Niveau o en est le Joueur n (N-1)
    FScoresJ:array[0..1] of integer; //Le score de chacun
    FViesJ:array[0..1] of integer;   //Le nombre de vies de chacun
    JoueurEnCours:byte; //C'est  qui le tour ?
    perdu:boolean;      //As-tu perdu ?
    FTemps: integer;    //O en est le temps (dans le jeu) ?

    NbrePommesDepart,NbrePommesRestantes:byte;
    TempsNiveau,TopDepart,TempsEcoule:cardinal;
    NbreSerpentsDepartJ1,NbreSerpentsDepartJ2:byte;

    //Lorsque le joueur complte un niveau il obtient un score
    //calcul savemment en fonction
    //du temps ralis, du temps de dpart et du niveau
    function CalculeFinNiveau(T,T0,LVL:integer):integer;
    //Lorsque le joueurse mange ou perd au temps il obtient un certain nombre
    //de points calculs en fonction du nombre de pommes qu'il a mang
    function CalculePerdu(NbrePommes:integer):integer;

    //Restitue graphiquement un lment du terrain de jeu
    procedure Render(X,Y:integer);
    //Restitue graphiquement un lment de terrain
    procedure RenderIntro(X,Y:integer;SpriteNum:byte);
    //Redessine tout, parce que pour gagner en vitesse, pendant le jeu et
    //l'intro on ne redessine habituellement que la "partie" de bitmap qui change
    //Ceci permet un raffrachissement total
    procedure RedessineTout;
    ///////////////////////////////////////////////////////
    //Serpent pendant le jeu
    procedure DrawSerpent;   //routine charge de le dessiner
    Procedure MoveSnake;     //routine charge de le dplacer
    Procedure Initialise;    //routine charge de l'initialiser en dbut de tableau
    ///////////////////////////////////////////////////////
    //Serpent pendant l'intro (HighScore/Instructions...)
    Procedure MoveSnakeIntro;    //dplacement
    Procedure InitialiseIntro;   //initialisation
    procedure DrawSerpentIntro;  //dessin
    ///////////////////////////////////////////////////////
    function Test(Direction:TDirection):TRTest; //test de collision
    procedure ChargeNouvelleGrille;             //chargement de la grille d'un nouveau niveau
    procedure BoucleJeu;                        //boucle de gestion du jeu (prise encompte
                                                //de la "dernire touche appuye", tests de collision
                                                //dplacement, gestion du gain de la perte
    procedure BoucleIntro;   //boucle d'affichage de l'cran d'accueil

    procedure ChargerEcranAcceuil;  //chargement de l'cran d'accueil et affichage
    procedure ChargeIntro;    //Chargement du texte correspondant au scores,
                              //aux diffrentesz pages d'instruction
    procedure AfficherScores; //oui, enfin, plutot de la zone de l'cran d'acceuil
                              //o sont affichs les scores, les instruction
    procedure CommencerJeu; //procdure qui lance une nouvelle partie
    ///////////////////////////////////
    //Gestion des Scores
    procedure ChargerScores;
    procedure SauverScores;
    procedure TrierScores;
    //////////////////////////////////
    procedure SetStyle(const Value: TStyle);
    procedure Setmode(const Value: TMode);

    function GetScoresJ(Index: Integer): integer;
    function GetViesJ(Index: Integer): integer;
    procedure SetScoresJ(Index: Integer; const Value: integer);
    procedure SetTemps(const Value: integer);
    procedure SetViesJ(Index: Integer; const Value: integer);
    function GetNiveauJ(Index: Integer): integer;
    procedure SetNiveauJ(Index: Integer; const Value: integer);
    procedure Son(Effet:string;flags:cardinal);

  public
    { Dclarations publiques }
    property Style:TStyle read FStyle write SetStyle;
    property mode:TMode read Fmode write Setmode;
    property Temps:integer read FTemps write SetTemps;
    property NiveauJ[Index: Integer]:integer read GetNiveauJ write SetNiveauJ;
    property ScoresJ[Index: Integer]:integer read GetScoresJ write SetScoresJ;
    property ViesJ[Index: Integer]:integer read GetViesJ write SetViesJ;
  end;

var
  Form1: TForm1;



implementation
uses mmsystem;
{$R *.dfm}
function AppPath:string;
begin
  Result:=ExtractFilePath(Application.ExeName);
end;

function RandomColor:TColor;
begin
  case random(5) of
    0:result:=clRed;
    1:result:=clAqua;
    2:result:=clLime;
    3:result:=clYellow;
    4:result:=clWhite;
    5:result:=clPurple;
    6:result:=clBlue;
  end;
end;

Procedure TForm1.DrawSerpent;
Var i,s : Byte;
    SpriteNum:byte;
Begin
  For i := 1 to Serpent.Count-2 Do
  Begin
    case Serpent.Anneaux[i].Direction of
      dGauche : SpriteNum:=8;
      dDroite : SpriteNum:=4;
      dHaut   : SpriteNum:=2;
      dBas    : SpriteNum:=1;
    end;

    case DirectionsOpposees[Serpent.Anneaux[i+1].Direction] of
      dGauche : SpriteNum:=SpriteNum or 8;
      dDroite : SpriteNum:=SpriteNum or 4;
      dHaut   : SpriteNum:=SpriteNum or 2;
      dBas    : SpriteNum:=SpriteNum or 1;
    end;

    s:=S_G;
    case SpriteNum of
      3:s:=S_TUD;
      5:s:=S_TRD;
      6:s:=S_TRU;
      9:s:=S_TLD;
      10:s:=S_TLU;
      12:s:=S_TLR;
      1:s:=S_TD;
      2:s:=S_TU;
      4:s:=S_TR;
      8:s:=S_TL;
    end;
    GrilleTerrain[Serpent.Anneaux[i].X, Serpent.Anneaux[i].Y]:=s;
    render(Serpent.Anneaux[i].X, Serpent.Anneaux[i].Y);
  End;


  case Serpent.Queue.Direction of
    dGauche : s:=S_TL;
    dDroite : s:=S_TR;
    dHaut   : s:=S_TU;
    dBas    : s:=S_TD;
  end;

  GrilleTerrain[Serpent.Queue.X, Serpent.Queue.Y]:=s;
  render(Serpent.Queue.X, Serpent.Queue.Y);

  case Serpent.Anneaux[1].Direction of
    dGauche : s:=S_HL;
    dDroite : s:=S_HR;
    dHaut   : s:=S_HU;
    dBas    : s:=S_HD;
  end;
  GrilleTerrain[Serpent.Tete.X, Serpent.Tete.Y]:=s;
  render(Serpent.Tete.X, Serpent.Tete.Y);
End;

Procedure TForm1.MoveSnake;
Var NouvelleTete:TAnneau;
    AncienneQueue:TAnneau;
Begin
 NouvelleTete:=Serpent.Tete;
 AncienneQueue:=Serpent.Queue;

 Case Serpent.Direction of
  dGauche : Dec(NouvelleTete.X);
  dDroite : Inc(NouvelleTete.X);
  dHaut   : Dec(NouvelleTete.Y);
  dBas    : Inc(NouvelleTete.Y);
 End;

 serpent.Insert(0,NouvelleTete);
 if Allonge=0 then begin
                     serpent.Delete(Serpent.Count-1);
                     GrilleTerrain[AncienneQueue.X, AncienneQueue.Y]:=s_G;
                     render(AncienneQueue.X, AncienneQueue.Y);
                   end
 else dec(allonge);
 DrawSerpent;
End;

Procedure TForm1.Initialise;
Var i : Byte;
    Anneau:TAnneau;
Begin
 Serpent.Clear;
 Serpent.Count:=9;
 For i := 0 to Serpent.Count-1 do
 Begin
   Anneau.X:= DepartSerpent.X-i;
   Anneau.Y:= DepartSerpent.Y;
   Anneau.Direction:=dDroite;
   Serpent.Anneaux[i]:=Anneau;
 End;
 
End;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  DoubleBuffered:=true;
  KeyPreview :=True;
  
  LblJ2.Visible:=False;
  LblV2.Visible:=false;
  lblPoints2.Visible:=false;
  LblVies2.Visible:=false;
  NbreSerpentsDepartJ1:=3;
  NbreSerpentsDepartJ2:=3;
  //Creation des bitmaps;
  Serpent:=TSerpent.Create;
  SerpentIntro:=TSerpent.Create;
  Affichage:=TBitmap.Create;
  AffichageAccueil:=TBitmap.Create;

  SpritesToonS:=TBitmap.Create;
  SpritesToonT:=TBitmap.Create;
  Sprites8bits:=TBitmap.Create;
  Instructions:=TStringList.Create;
  IntroLignes:=TStringList.Create;

  //Chargement des sprites;
  SpritesToonS.LoadFromFile(AppPath+'toon_s.bmp');
  SpritesToonT.LoadFromFile(AppPath+'toon_t.bmp');
  Sprites8bits.LoadFromFile(AppPath+'8bits.bmp');
  //Chargement des instructions
  Instructions.LoadFromFile(AppPath+'instructions.txt');

  //Dimensionnement des bitmaps
  Affichage.Width:=TerrainW*16;
  Affichage.Height:=TerrainH*16;
  AffichageAccueil.Width:=16*36;
  AffichageAccueil.Height:=16*29;
  Style:=sToon;

  ChargerEcranAcceuil;
  ChargerScores;
  modecounter:=-1;
  Mode:=mHighScores;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //Destruction des bitmaps;
  SpritesToonS.Free;
  SpritesToonT.Free;
  Sprites8bits.Free;
  Serpent.Free;
  SerpentIntro.Free;
  Affichage.Free;
  AffichageAccueil.Free;
  Instructions.Free;
  IntroLignes.Free;
end;

procedure TForm1.PaintBoxJeuPaint(Sender: TObject);
begin
  PaintBoxJeu.Canvas.Draw(0,0,Affichage);
end;

procedure TForm1.Render(X, Y: integer);
var Rect1,Rect2:TRect;
    u:integer;
begin
  if (x<0) or (y<0) or (x>=TerrainW) or (y>=TerrainH) then exit;
  Rect1:=Bounds(16*x,16*y,16,16);
  case Style of
  s8bits:begin
           Rect2:=Bounds(16,(NiveauGrille-1)*16,16,16);
           Affichage.Canvas.CopyRect(Rect1,Sprites8bits.Canvas,Rect2);
         end;
  sToon:begin
          Rect2:=Bounds(19*17,0,16,16);
          Affichage.Canvas.CopyRect(Rect1,SpritesToonS.Canvas,Rect2);
        end;
  end;
  if grilleTerrain[x,y]>=100 //rocher ou herbe
  then begin
         u:=grilleTerrain[x,y]-100;
         case Style of
         s8bits:if u>12 then //c'est un fruit !
                begin
                  Rect2:=Bounds(0,(NiveauGrille-1)*16,16,16);
                  Affichage.Canvas.CopyRect(Rect1,Sprites8bits.Canvas,Rect2);
                end
                else begin
                       Affichage.Canvas.Brush.Color:=clBlack;
                       Affichage.Canvas.FillRect(Rect1);
                     end;
          sToon:begin
                  Rect2:=Bounds(u*17,0,16,16);
                  Affichage.Canvas.CopyRect(Rect1,SpritesToonT.Canvas,Rect2);
                end;
         end;
       end
  else if grilleTerrain[x,y]<>S_G then
  begin
    u:=grilleTerrain[x,y];
    case Style of
         s8bits:begin
                  case u of
                     //Tte du serpent
                     0..3  :Rect2:=Bounds(32,(NiveauGrille-1)*16,16,16);
                     //anneau ou queue
                     4..13 :Rect2:=Bounds(16,(NiveauGrille-1)*16,16,16);
                     //Pomme
                     14..18:Rect2:=Bounds(48,(NiveauGrille-1)*16,16,16);
                  end;
                  Affichage.Canvas.CopyRect(Rect1,Sprites8bits.Canvas,Rect2);
                end;
          sToon:begin
                  Rect2:=Bounds(u*17,0,16,16);
                  Affichage.Canvas.CopyRect(Rect1,SpritesToonS.Canvas,Rect2);
                end;
         end;
  end;
end;



procedure VideBufferClavier;
var Msg: TMsg;
begin
  while PeekMessage(Msg, 0, WM_KEYFIRST, WM_KEYLAST,
    PM_REMOVE or PM_NOYIELD) do;
end;

function TForm1.Test(Direction: TDirection): TRTest;
var Obstacle:byte;
begin
  result:=rRien;
  Case Direction of
    dGauche : if serpent.tete.X=0
              then result:=rBord
              else Obstacle:=GrilleTerrain[serpent.tete.X-1,serpent.tete.Y];
    dDroite : if serpent.tete.X=terrainW-1
              then result:=rBord
              else Obstacle:=GrilleTerrain[serpent.tete.X+1,serpent.tete.Y];
    dHaut   : if serpent.tete.Y=0
              then result:=rBord
              else Obstacle:=GrilleTerrain[serpent.tete.X,serpent.tete.Y-1];
    dBas    : if serpent.tete.Y=terrainH-1
              then result:=rBord
              else Obstacle:=GrilleTerrain[serpent.tete.X,serpent.tete.Y+1];
  end;
  if result=rBord then exit;

  if ((Obstacle>=100) and (Obstacle<>112)) then result:=rRocher
  else if Obstacle<=13 then result:=rSerpent
       else if ((Obstacle>=S_M) and (Obstacle<=(S_M+5))) then result:=rPomme;
end;

function TForm1.CalculeFinNiveau(T, T0, LVL: integer): integer;
begin
  result:=round((10000+T0-T)*LVL/5);
end;

function TForm1.CalculePerdu(NbrePommes: integer): integer;
begin
  case NbrePommes of
  0:result:=0;
  1:result:=6;
  else result:=8*NbrePommes*NbrePommes+2*NbrePommes-15;
  end;
end;

procedure TForm1.ChargeNouvelleGrille;
var i,j,k:byte;
    FichierGrille:TStringList;
    NomFichier:string;
    Ligne:string;
begin
  NiveauGrille:=(FNiveauJ[JoueurEnCours] mod 5)+1;
  NbrePommesDepart:=0;
  FichierGrille:=TStringList.Create;
  try
    NomFichier:=AppPath+'L'+IntToStr(NiveauGrille)+'.txt';
    FichierGrille.LoadFromFile(NomFichier);
    for j:=0 to TerrainH-1 do
    begin
      Ligne:=FichierGrille.Strings[j];
      for i:=0 to TerrainW-1 do
        GrilleNiveau[i,j]:=ligne[i+1];
    end;
  finally
  FichierGrille.Free;
  end;

  for i:=0 to TerrainW-1 do
    for j:=0 to TerrainH-1 do
    begin
      if GrilleNiveau[i,j]='S' then
      begin
        GrilleNiveau[i,j]:=' ';
        DepartSerpent:=Point(i,j);
      end;
      case GrilleNiveau[i,j] of
        ' ':grilleTerrain[i,j]:=S_G;

        '0':begin
              k:=113+random(30);
              if k>116 then k:=117;
              grilleTerrain[i,j]:=k;
            end;
        '*':begin
              k:=0;
              if GrilleNiveau[i-1,j-1] in ['0','O'] then k:=k or 8;
              if GrilleNiveau[i+1,j+1] in ['0','O'] then k:=k or 2;
              if GrilleNiveau[i+1,j-1] in ['0','O'] then k:=k or 1;
              if GrilleNiveau[i-1,j+1] in ['0','O'] then k:=k or 4;
            grilleTerrain[i,j]:=Rochers[k];
          end;
          'O':begin
              k:=0;
              if GrilleNiveau[i-1,j]='0' then k:=k or 12;
              if GrilleNiveau[i+1,j]='0' then k:=k or 3;
              if GrilleNiveau[i,j-1]='0' then k:=k or 9;
              if GrilleNiveau[i,j+1]='0' then k:=k or 6;
            grilleTerrain[i,j]:=Rochers[k];
          end;
        'P':begin
              grilleTerrain[i,j]:=S_M+NiveauGrille-1;
              inc(NbrePommesDepart);
            end;
      end;
      render(i,j);
    end;
  NbrePommesRestantes:=NbrePommesDepart;
end;

procedure TForm1.BoucleJeu;
const Mask: WORD = 32768;
var deplace:boolean;
    pomme:boolean;
    rTest:TRTest;
    i,scoreTemp:integer;
    UnNom:string;
    PtsAvant,PtsApres:integer;
begin
  TempsEcoule:=(GetTickCount-TopDepart) div 10;
  temps:=TempsNiveau+TempsEcoule;
  Application.ProcessMessages;
  perdu:=false;
  pomme:=false;
  if Temps>9999 then perdu:=true;
  if not (GetAsyncKeyState(VK_ESCAPE) and Mask = 0)
  then perdu:=true
  else begin
          case DerniereToucheAppuyee of
            VK_UP   :if Test(dHaut)<>rRocher then begin
                                                    Serpent.Direction:=dHaut;
                                                    VideBufferClavier;
                                                    DerniereToucheAppuyee:=0;
                                                  end;
            VK_DOWN :if Test(dBas)<>rRocher then begin
                                                    Serpent.Direction:=dBas;
                                                    VideBufferClavier;
                                                    DerniereToucheAppuyee:=0;
                                                  end;
            VK_LEFT :if Test(dGauche)<>rRocher then begin
                                                      serpent.Direction:=dGauche;
                                                    VideBufferClavier;
                                                    DerniereToucheAppuyee:=0;
                                                  end;
            VK_RIGHT:if Test(dDroite)<>rRocher then begin
                                                      Serpent.Direction:=dDroite;
                                                    VideBufferClavier;
                                                    DerniereToucheAppuyee:=0;
                                                  end;
          end;

          deplace:=true;
          rTest:=Test(Serpent.Direction);
          if ((rTest=rBord) or (rTest=rRocher)) then deplace:=false
          else if rTest=rSerpent then perdu:=true
          else pomme:=(rTest=rPomme);

          if perdu then
          begin
            Timer1.Enabled:=false;
            if rTest=rSerpent then MoveSnake;
            PaintBoxJeu.Repaint;
            son('ohno',SND_SYNC);
            ViesJ[JoueurEnCours]:=ViesJ[JoueurEnCours]-1;
            scoreTemp:=scoresJ[JoueurEnCours];
            for i:=1 to (NbrePommesDepart-NbrePommesRestantes) do
            begin
              PtsAvant:=scoresJ[JoueurEnCours];
              scoresJ[JoueurEnCours]:=scoreTemp+CalculePerdu(i);
              PtsApres:=scoresJ[JoueurEnCours];
              if (((PtsAvant<Bonus1) and (PtsApres>=Bonus1))
               or ((PtsAvant<Bonus2) and (PtsApres>=Bonus2))
               or ((PtsAvant<Bonus3) and (PtsApres>=Bonus3)))
              then ViesJ[JoueurEnCours]:=ViesJ[JoueurEnCours]+1;
              Application.ProcessMessages;
              sleep(300);
            end;

            if NbreJoueurs=2 then JoueurEnCours:=1-JoueurEnCours;
            while (ViesJ[JoueurEnCours]=0) and ((ViesJ[0]+ViesJ[1])<>0) do
                  JoueurEnCours:=1-JoueurEnCours;
            if (ViesJ[0]+ViesJ[1])<>0
            then CommencerJeu
            else begin
                   if scoresJ[0]>Scores[9].Score
                   then begin
                          son('applause',SND_SYNC);
                          case style of
                             s8bits:ScoreQuery('C''est un nouveau record !','Joueur 1, quel est votre nom ?',UnNom,clBlack,RandomColor);
                             sToon:ScoreQuery('C''est un nouveau record !','Joueur 1, quel est votre nom ?',UnNom,$0017D960,clpurple);
                          end;
                          Scores[10].Nom:=UnNom;
                          Scores[10].Score:=scoresJ[0];
                          TrierScores;
                          SauverScores;
                          ChargerScores;
                          AfficherScores;
                        end;
                   if scoresJ[1]>Scores[9].Score
                   then begin
                          son('applause',SND_SYNC);
                          case style of
                             s8bits:ScoreQuery('C''est un nouveau record !','Joueur 2, quel est votre nom ?',UnNom,clBlack,RandomColor);
                             sToon:ScoreQuery('C''est un nouveau record !','Joueur 2, quel est votre nom ?',UnNom,$0017D960,clpurple);
                          end;
                          Scores[10].Nom:=UnNom;
                          Scores[10].Score:=scoresJ[1];
                          TrierScores;
                          SauverScores;
                          ChargerScores;
                          AfficherScores;
                        end;
                   mode:=mHighScores;
                 end;
          end else
          begin
            if pomme then begin
                            allonge:=allonge+3;
                            Son('eat',SND_ASYNC);
                            dec(NbrePommesRestantes);
                            if NbrePommesRestantes=0
                            then begin
                                   Timer1.Enabled:=false;
                                   scoreTemp:=scoresJ[JoueurEnCours];
                                   for i:=11000 downto temps do
                                   begin
                                     PtsAvant:=scoresJ[JoueurEnCours];
                                     scoresJ[JoueurEnCours]:=scoreTemp+CalculeFinNiveau(i,1000,niveauJ[JoueurEnCours]+1);
                                      PtsApres:=scoresJ[JoueurEnCours];
                                    if (((PtsAvant<Bonus1) and (PtsApres>=Bonus1))
                                     or ((PtsAvant<Bonus2) and (PtsApres>=Bonus2))
                                     or ((PtsAvant<Bonus3) and (PtsApres>=Bonus3)))
                                    then ViesJ[JoueurEnCours]:=ViesJ[JoueurEnCours]+1;
                                     Application.ProcessMessages;
                                     if (i mod 500)=0 then sleep(300);
                                   end;
                                   niveauJ[JoueurEnCours]:=niveauJ[JoueurEnCours]+1;
                                   CommencerJeu;
                                 end;
                          end else Son('move',SND_ASYNC);
            if deplace then MoveSnake;
            DrawSerpent;
          end;
          PaintBoxJeu.Repaint;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  case FMode of
    mHighScores,mInstructions1,mInstructions2,mInstructions3,mInstructions4:
         begin
           inc(modecounter);
           if modecounter=500 then modecounter:=0;
           if modecounter=0 then Mode:=mHighScores;
           if modecounter=100 then Mode:=mInstructions1;
           if modecounter=200 then Mode:=mInstructions2;
           if modecounter=300 then Mode:=mInstructions3;
           if modecounter=400 then Mode:=mInstructions4;
           BoucleIntro;
         end;
    mJeu:BoucleJeu;
  end;
end;

procedure TForm1.Toons1Click(Sender: TObject);
begin
  Style:=sToon;
  form1.Color:=$0017D960;
  RedessineTout;
  InitialiseIntro;
  Toons1.Checked:=true;
  lblPoints1.Font.Color:=clBlack;
  LblVies1.Font.Color:=clBlack;
  lblPoints2.Font.Color:=clBlack;
  LblVies2.Font.Color:=clBlack;
  LblTemps.Font.Color:=clBlack;
  form1.repaint;
end;

procedure TForm1.N8bits1Click(Sender: TObject);
begin
  Style:=s8bits;
  form1.Color:=clBlack;
  RedessineTout;
  InitialiseIntro;
  N8bits1.Checked:=true;
  lblPoints1.Font.Color:=clWhite;
  LblVies1.Font.Color:=clWhite;
  lblPoints2.Font.Color:=clWhite;
  LblVies2.Font.Color:=clWhite;
  LblTemps.Font.Color:=clWhite;
  form1.repaint;
end;

procedure TForm1.NouvellePartie1Click(Sender: TObject);
begin
  mode:=mJeu;
end;

procedure TForm1.RedessineTout;
var i,j:integer;
begin
  ChargerEcranAcceuil;
  for i:=0 to TerrainW-1 do
  for j:=0 to TerrainH-1 do
  begin
    render(i,j);
  end;
end;

procedure TForm1.SetStyle(const Value: TStyle);
begin
  FStyle := Value;
end;

procedure TForm1.ChargerScores;
var Fichier:TStringList;
    i:integer;
    s,s0,s1,s2:string;
begin
  Fichier:=TStringList.Create;
  try
    Fichier.LoadFromFile(ExtractFilePath(Application.ExeName)+'scores.txt');
    for i:=0 to 9 do
    begin
      Scores[i].Nom:=Fichier.Names[i];
      Scores[i].Score:=StrToInt(Fichier.ValueFromIndex[i]);
      s:='  . ......................';
      s0:=IntToStr(i+1);
      s1:=Scores[i].Nom;
      s2:=IntToStr(scores[i].Score);
      move(s0[1],s[3-length(s0)],length(s0));
      move(s1[1],s[5],length(s1));
      move(s2[1],s[length(s)-length(s2)+1],length(s2));
      Scores[i].Affichage:=s;
    end;

  finally
    Fichier.Free;
  end;
  AfficherScores;
end;

procedure TForm1.SauverScores;
var Fichier:TStringList;
    i:integer;
begin
  Fichier:=TStringList.Create;
  try
    for i:=0 to 9 do
    begin
      Fichier.Add(Scores[i].Nom+'='+IntToStr(Scores[i].Score));
    end;
    Fichier.SaveToFile(ExtractFilePath(Application.ExeName)+'scores.txt');
  finally
    Fichier.Free;
  end;
end;

procedure TForm1.AfficherScores;
var i:integer;
    w:integer;
    l:integer;
    offset:byte;
    R:TRect;
    s:string;
    y:integer;
begin
  with PaintBoxIntro.Canvas do
  begin
    Font.Name:='Lucida Console';
    Font.Height:=16;
    Font.Style:=[fsBold];
    offset:=0;
    Brush.color:=$68C0E4;
    Font.color:=clPurple;

    if FStyle=s8bits
    then begin
           offset:=2;
           Brush.Color:=clBlack;
           Font.Color:=RandomColor;
         end;
    R:=bounds(32,16*(14+offset),16*33,216);
    FillRect(R);
    w:=TextWidth(IntroTitre);
    TextOut(16*18-(w div 2),16*(14+offset),IntroTitre);
    if FMode=mHighScores
    then w:=TextWidth(' ')*26
    else w:=TextWidth(' ')*40;
    l:=16*18-(w div 2);
    y:=16*(16+offset);
    for i:=0 to IntroLignes.Count-1 do
    begin
      s:=IntroLignes.Strings[i];
      if FStyle=s8bits
      then Font.Color:=RandomColor;
      TextOut(l,Y,s);
      inc(y,16);
    end;
  end;
end;

procedure TForm1.PaintBoxIntroPaint(Sender: TObject);
begin
  PaintBoxIntro.Canvas.Draw(0,0,AffichageAccueil);
  AfficherScores;
end;

procedure TForm1.ChargerEcranAcceuil;
var i,j:integer;
    asl:TStringList;
    s:string;
    Rs,Rd:TRect;
    SpriteNum:byte;
begin
  asl:=TStringList.Create;
  try
    if style=sToon
    then asl.LoadFromFile(AppPath+'intro.txt')
    else asl.LoadFromFile(AppPath+'intro8.txt');

    for j:=0 to 28 do
    begin
       s:=asl.Strings[j];
       for i:=0 to 35 do
       begin
         Rd:=Bounds(i*16,j*16,16,16);
         case Fstyle of
         s8bits:begin
                  case s[i+1] of
                  'R':begin
                        Rs:=Bounds(0,16,16,16);
                        AffichageAccueil.Canvas.CopyRect(Rd,Sprites8bits.Canvas,Rs);
                      end;
                  '1':begin
                        AffichageAccueil.Canvas.Brush.Color:=clYellow;
                        AffichageAccueil.Canvas.FillRect(Rd);
                      end;
                  '2':begin
                        AffichageAccueil.Canvas.Brush.Color:=clRed;
                        AffichageAccueil.Canvas.FillRect(Rd);
                      end;
                  else begin
                           AffichageAccueil.Canvas.Brush.Color:=clBlack;
                           AffichageAccueil.Canvas.FillRect(Rd);
                         end
                  end;
                end;
         sToon :begin
                  SpriteNum:=(ord(s[i+1])-65);
                  if SpriteNum=17 then spritenum:=13+random(20);
                  if SpriteNum>17 then SpriteNum:=17;
                  rs:=Bounds(SpriteNum*17,0,16,16);
                  AffichageAccueil.Canvas.CopyRect(Rd,SpritesToonT.Canvas,Rs);
                end;
         end;
         
       end;
    end;
  finally
    asl.Free;
  end;
  PaintBoxIntro.Repaint;
end;

procedure TForm1.SetMode(const Value: TMode);
begin
  //if Fmode<>Value then
  begin
    Fmode := Value;
    case FMode of
      mHighScores:modecounter:=0;
      mInstructions1:modecounter:=100;
      mInstructions2:modecounter:=200;
      mInstructions3:modecounter:=300;
      mInstructions4:modecounter:=400;
    end;

    case FMode of
      mHighScores:
           begin
             Timer1.Enabled:=false;
             NouvellePartie1.Enabled:=true;
             N1Joueur1.Enabled:=true;
             N2Joueurs1.Enabled:=true;
             PanelIntro.Visible:=true;
             PaintBoxJeu.Visible:=false;
             PanelJeu.Visible:=false;
             Timer1.Interval:=100;
             PaintBoxIntro.Repaint;
             ChargeIntro;
             InitialiseIntro;
             DrawSerpentIntro;
             Timer1.Enabled:=true;
           end;
      mInstructions1,mInstructions2,mInstructions3,mInstructions4:ChargeIntro;
      mJeu:begin
             DerniereToucheAppuyee:=-1;
             Timer1.Enabled:=false;
             NouvellePartie1.Enabled:=false;
             N1Joueur1.Enabled:=false;
             N2Joueurs1.Enabled:=false;
             modecounter:=-1;
             PanelIntro.Visible:=false;
             PaintBoxJeu.Visible:=true;
             PanelJeu.Visible:=true;
             JoueurEnCours:=0;
             NiveauJ[0]:=0;
             NiveauJ[1]:=0;
             ScoresJ[0]:=0;
             ScoresJ[1]:=0;
             ViesJ[0]:=NbreSerpentsDepartJ1;
             if NbreJoueurs=2
             then ViesJ[1]:=NbreSerpentsDepartJ2
             else ViesJ[1]:=0;
             CommencerJeu;
           end;
    end;
  end;
end;

procedure TForm1.BoucleIntro;
var YBottom:integer;
begin
  if style=s8bits then  AfficherScores;
  if style=s8bits then YBottom:=12 else ybottom:=10;

  with SerpentIntro do
  begin
    if ((Tete.X=32) and (Tete.Y=YBottom))
    then Direction:=dHaut;
    if ((Tete.X=32) and (Tete.Y=2))
    then Direction:=dGauche;
    if ((Tete.X=3) and (Tete.Y=2))
    then Direction:=dBas;
    if ((Tete.X=3) and (Tete.Y=YBottom))
    then SerpentIntro.Direction:=dDroite;
  end;
  MoveSnakeIntro;
  DrawSerpentIntro;
end;

procedure TForm1.ResetdesScores1Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to 9 do scores[i].Nom:='Cobra';
  for i:=0 to 4 do scores[i].Score:=(5-i)*10000;
  for i:=0 to 4 do scores[i+5].Score:=(5-i)*1000;
  SauverScores;
  ChargerScores;
  ChargeIntro;
  AfficherScores;
end;

procedure TForm1.ChargeIntro;
var i:integer;
begin
  IntroLignes.Clear;
  case FMode of
      mHighScores:begin
                    IntroTitre:='Hall of fames';
                      for i:=0 to 9 do IntroLignes.Add(scores[i].Affichage);
                  end;
      mInstructions1:begin
                    IntroTitre:='Instructions 1/3';
                    If Instructions.Count>10 then
                    for i:=0 to 10 do IntroLignes.Add(Instructions.Strings[i]);
                  end;
      mInstructions2:begin
                    IntroTitre:='Instructions 2/3';
                    If Instructions.Count>20 then
                    for i:=11 to 20 do IntroLignes.Add(Instructions.Strings[i]);
                  end;
      mInstructions3:begin
                    IntroTitre:='Instructions 3/3';
                    If Instructions.Count>31 then
                    for i:=22 to 31 do IntroLignes.Add(Instructions.Strings[i]);
                  end;
      mInstructions4:begin
                    IntroTitre:='';
                    If Instructions.Count>32 then
                    for i:=32 to Instructions.Count-1 do IntroLignes.Add(Instructions.Strings[i]);
                  end;
  end;
  if style=stoon then AfficherScores;
end;

procedure TForm1.InitialiseIntro;
Var i : Byte;
    Anneau:TAnneau;
    ybottom:integer;
Begin
 case NbreJoueurs of
 1:SpritesToonS.LoadFromFile(AppPath+'toon_s.bmp');
 2:SpritesToonS.LoadFromFile(AppPath+'toon_s2.bmp');
 end;
 SerpentIntro.Clear;
 SerpentIntro.Count:=9;
 if style=s8bits then YBottom:=12 else ybottom:=10;
 For i := 0 to SerpentIntro.Count-1 do
  Begin
    Anneau.X:=22-i;
    Anneau.Y:=ybottom;
    Anneau.Direction:=dDroite;
    SerpentIntro.Anneaux[i]:=Anneau;
  End;
End;

procedure TForm1.MoveSnakeIntro;
Var NouvelleTete:TAnneau;
    AncienneQueue:TAnneau;
Begin
 NouvelleTete:=SerpentIntro.Tete;
 AncienneQueue:=SerpentIntro.Queue;

 
 Case SerpentIntro.Direction of
  dGauche : Dec(NouvelleTete.X);
  dDroite : Inc(NouvelleTete.X);
  dHaut   : Dec(NouvelleTete.Y);
  dBas    : Inc(NouvelleTete.Y);
 End;

 SerpentIntro.Insert(0,NouvelleTete);
 SerpentIntro.Delete(SerpentIntro.Count-1);
 RenderIntro(AncienneQueue.X, AncienneQueue.Y,S_G);
 //DrawSerpentIntro;
End;

procedure TForm1.DrawSerpentIntro;
Var i,s : Byte;
    SpriteNum:byte;
Begin
  case SerpentIntro.Anneaux[1].Direction of
    dGauche : s:=S_HL;
    dDroite : s:=S_HR;
    dHaut   : s:=S_HU;
    dBas    : s:=S_HD;
  end;
  RenderIntro(SerpentIntro.Tete.X, SerpentIntro.Tete.Y,s);

  For i := 1 to SerpentIntro.Count-2 Do
  Begin
    case SerpentIntro.Anneaux[i].Direction of
      dGauche : SpriteNum:=8;
      dDroite : SpriteNum:=4;
      dHaut   : SpriteNum:=2;
      dBas    : SpriteNum:=1;
    end;

    case DirectionsOpposees[SerpentIntro.Anneaux[i+1].Direction] of
      dGauche : SpriteNum:=SpriteNum or 8;
      dDroite : SpriteNum:=SpriteNum or 4;
      dHaut   : SpriteNum:=SpriteNum or 2;
      dBas    : SpriteNum:=SpriteNum or 1;
    end;

    s:=S_G;
    case SpriteNum of
      3:s:=S_TUD;
      5:s:=S_TRD;
      6:s:=S_TRU;
      9:s:=S_TLD;
      10:s:=S_TLU;
      12:s:=S_TLR;
    end;
    RenderIntro(SerpentIntro.Anneaux[i].X, SerpentIntro.Anneaux[i].Y,s);
  End;

  case SerpentIntro.Queue.Direction of
    dGauche : s:=S_TL;
    dDroite : s:=S_TR;
    dHaut   : s:=S_TU;
    dBas    : s:=S_TD;
  end;
  RenderIntro(SerpentIntro.Queue.X, SerpentIntro.Queue.Y,s);
End;

procedure TForm1.RenderIntro(X, Y: integer;SpriteNum:byte);
var Rect1,Rect2:TRect;
begin
  Rect1:=Bounds(16*x,16*y,16,16);
  case Style of
  s8bits:begin
           Rect2:=Bounds(16,16,16,16);
           PaintBoxIntro.Canvas.FillRect(Rect1);
         end;
  sToon:begin
          Rect2:=Bounds(19*17,0,16,16);
          PaintBoxIntro.Canvas.CopyRect(Rect1,SpritesToonS.Canvas,Rect2);
        end;
  end;
  if SpriteNum<>S_G then
  begin
    case Style of
         s8bits:begin
                  case SpriteNum of
                     0..3  :Rect2:=Bounds(32,16,16,16);
                     4..13 :Rect2:=Bounds(16,16,16,16);
                  end;
                  PaintBoxIntro.Canvas.CopyRect(Rect1,Sprites8bits.Canvas,Rect2);
                end;
          sToon:begin
                  Rect2:=Bounds(SpriteNum*17,0,16,16);
                  PaintBoxIntro.Canvas.CopyRect(Rect1,SpritesToonS.Canvas,Rect2);
                end;
         end;
  end;
end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Resize:=false;
end;

procedure LabelClignote(ALabel:TLabel);
begin
  ALabel.Visible:=false;
  Application.ProcessMessages;
  sleep(200);
  ALabel.Visible:=true;
  Application.ProcessMessages;
  sleep(200);
end;

procedure TForm1.CommencerJeu;
var r:TRect;
    w:Integer;
    ALabel:TLabel;
    inter:integer;
begin
  ChargeNouvelleGrille;
  case JoueurEnCours of
  0:SpritesToonS.LoadFromFile(AppPath+'toon_s.bmp');
  1:SpritesToonS.LoadFromFile(AppPath+'toon_s2.bmp');
  end;
  Initialise;
  TempsNiveau:=500*NiveauJ[JoueurEnCours];
  if TempsNiveau>8000 then TempsNiveau:=8500;
  Temps:=TempsNiveau;
  perdu:=false;
  if JoueurEnCours=0 then ALabel:=lblJ1 else ALabel:=LblJ2;
  PaintBoxJeu.Repaint;
  with Affichage.Canvas do
  begin
    Brush.Color:=$68C0E4;
    brush.Style:=bsSolid;
    Font.color:=clPurple;
    Font.Name:='Lucida Console';
    Font.Style:=[fsBold];
    Font.Height:=16;
    if FStyle=s8bits
    then begin
           Brush.Color:=clBlack;
           Font.Color:=RandomColor;
         end;
    w:=TextWidth('A vos marques...');
    with serpent do
    R:=bounds((Affichage.Width-w) div 2,queue.Y*16,w,16);
    with Serpent.Queue do
    begin
      Son('power',SND_SYNC);
      FillRect(R);
      w:=TextWidth('A vos marques...');
      TextOut((Affichage.Width-w) div 2,R.Top,'A vos marques...');
      PaintBoxJeu.Repaint;
      Application.ProcessMessages;
      LabelClignote(ALabel);
      FillRect(R);
      w:=TextWidth('Prt ?');
      TextOut((Affichage.Width-w) div 2,R.Top,'Prt ?');
      PaintBoxJeu.Repaint;
      Application.ProcessMessages;
      LabelClignote(ALabel);
      FillRect(R);
      w:=TextWidth('Partez !!!');
      TextOut((Affichage.Width-w) div 2,R.Top,'Partez !!!');
      PaintBoxJeu.Repaint;
      Application.ProcessMessages;
      LabelClignote(ALabel);
    end;
  end;
  inter:=100-TempsNiveau div 100;
  if inter<0 then inter:=0;
  timer1.Interval:=inter;

  DrawSerpent;
  TopDepart:=GetTickCount;
  Timer1.Enabled:=true;
end;

function TForm1.GetScoresJ(Index: Integer): integer;
begin
  Result:=FScoresJ[index];
end;

function TForm1.GetViesJ(Index: Integer): integer;
begin
  Result:=FViesJ[index];
end;

procedure TForm1.SetScoresJ(Index: Integer; const Value: integer);
begin
  FScoresJ[index]:=Value;
  case index of
    0:lblPoints1.Caption:=IntToStr(Value);
    1:lblPoints2.Caption:=IntToStr(Value);
  end;
end;

procedure TForm1.SetTemps(const Value: integer);
begin
  FTemps := Value;
  if ftemps>9999 then LblTemps.Caption:='9999'
  else  LblTemps.Caption:=IntToStr(Value);
end;

procedure TForm1.SetViesJ(Index: Integer; const Value: integer);
begin
  FViesJ[index]:=Value;
  case index of
    0:LblVies1.Caption:=IntToStr(Value);
    1:LblVies2.Caption:=IntToStr(Value);
  end;
end;

function TForm1.GetNiveauJ(Index: Integer): integer;
begin
  result:=FNiveauJ[index];
end;

procedure TForm1.SetNiveauJ(Index: Integer; const Value: integer);
begin
  FNiveauJ[Index]:= Value;
end;

procedure TForm1.Son(Effet: string;flags:cardinal);
begin
  if Son1.Checked then
  JouerSon(AppPath+Effet+'.wav',flags);
end;

procedure TForm1.N2Joueurs1Click(Sender: TObject);
begin
  NbreJoueurs:=2;
  SpritesToonS.LoadFromFile(AppPath+'toon_s2.bmp');
  N2Joueurs1.Checked:=true;
  LblJ2.Visible:=true;
  LblV2.Visible:=true;
  lblPoints2.Visible:=true;
  LblVies2.Visible:=true;
end;

procedure TForm1.N1Joueur1Click(Sender: TObject);
begin
  NbreJoueurs:=1;
  SpritesToonS.LoadFromFile(AppPath+'toon_s.bmp');
  N1Joueur1.Checked:=true;
  LblJ2.Visible:=False;
  LblV2.Visible:=false;
  lblPoints2.Visible:=false;
  LblVies2.Visible:=false;
end;

procedure TForm1.TrierScores;
var i,j:integer;
    Temp:TScore;
begin
  for i:=0 to 9 do  //count-2
    for j:=10 downto (i+1) do //count-1 to..
      if scores[i].Score<scores[j].Score then
      begin
        Temp:=scores[i];
        scores[i]:=scores[j];
        scores[j]:=temp;
      end;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer1.Enabled:=false;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    VK_F1:NbreSerpentsDepartJ1:=8-NbreSerpentsDepartJ1;
    VK_F12:NbreSerpentsDepartJ2:=8-NbreSerpentsDepartJ2;
    VK_F10:begin
             Timer1.Enabled:=false;
              Close;
           end;
    VK_ESCAPE:begin
                Timer1.Enabled:=false;
                mode:=mHighScores;
              end;
    VK_UP,VK_DOWN,VK_LEFT,VK_RIGHT:DerniereToucheAppuyee:=Key;
    ord('P'):if Fmode=mJeu then Timer1.Enabled:=not Timer1.Enabled;
  end;
end;

end.
