unit Unit2;
//unit "boite  outils"
//- gestion basique du serpent grace  une classe TSerpent qui encapsule une TList
//-La boite de dialogue pour rentre son nom lorsqu'on obtient un high-score
//-une fonction pour jouer un fichier son (wav) se trouvant sur le disque dur (1 ligne de code)
interface
uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,stdCtrls,buttons;

type
  //4 directions possibles sont prises par le serpent, ses anneaux et sa queue
  TDirection=(dGauche,dDroite,dHaut,dBas);

const
  DirectionsOpposees:array[dGauche..dBas] of
                     TDirection=(dDroite,dGauche,dBas,dHaut);

type
  //Un anneau, sur le terrai, est caractris par sa position (X,Y)
  //et la direction vers o il se dirige. La tte est le premier anneau,
  //sa queue, son dernier
  TAnneau=Record
    X,Y:integer;
    Direction:TDirection;
  End;

  PTAnneau = ^TAnneau;

  //Un serpent est une liste d'anneau
  //l'utilisation d'un TList permet ici d'avoir une structure qui puisse
  //"s'allonger" (ou se raccourcir) comme notre serpent !
  TSerpent = class(TObject)
  private
    FList:TList;
    function GetAnneau(Index: Integer): TAnneau;
    procedure SetAnneau(Index: Integer; const Value: TAnneau);
    function GetCount: Integer;
    procedure SetCount(const Value: Integer);
    function GetDirection: TDirection;
    procedure SetDirection(const Value: TDirection);
    procedure SetQueue(const Value: TAnneau);
    procedure SetTete(const Value: TAnneau);
    function GetQueue: TAnneau;
    function GetTete: TAnneau;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    //permet d'allonger le serpent en ajoutant un anneau  la fin
    //(qui devient la nouvelle queue)
    function Add(Anneau:TAnneau): Integer;
    //permet de supprimer un anneau (par exemple la queue)
    procedure Delete(Index: Integer);
    //permet d'insrer un anneau (en particulier en tte du serpent
    //pour l'allonger sans dplacer la queue)
    procedure Insert(Index: Integer; Anneau: TAnneau);
    //Ainsi, pour faire avancer le serpent,
    //il suffit de rajouter un anneau en-tete du serpent, et d'effacer la queue

    //permet d'obtenir un serpent de longueur nulle
    procedure Clear;
    //Permet d'acceder d'accder  chacun des anneaux
    property Anneaux[Index:Integer]:TAnneau read GetAnneau write SetAnneau;default;
    //permet d'accder  la tte (premier anneau)
    property Tete:TAnneau read GetTete write SetTete;
    //permet d'accder  la queue, dernier anneau
    property Queue:TAnneau read GetQueue write SetQueue;
    //Permet de connatre la longeur du reptile, tte et queue comprises
    property Count: Integer read GetCount write SetCount;
    //Permet de savoir dans quelle direction se dplace le serpent (sa tte donc)
    property Direction:TDirection read GetDirection write SetDirection;
  end;

//c'est une fonction qui affiche une boite de dialogue permettant de rentrer son score
//ACaption : Texte de la barre de titre
//APrompt : sera "Joueur 1 (ou Joueur2), votre nom  SVP)
//Value : le nom entr par le joueur dans un TEdit (qui accepte dix caractres)
//ABgColor, AFontColor : sont resctivement les couleurs de fond et de police
//                       avec lesquelles s'affichera la boite de dialogue
//                       selon le thme choisi par l'utilisateur
function ScoreQuery(const ACaption, APrompt: string;
   var Value: string;ABgColor,FontColor:TColor): Boolean;

//permet de jouer simplement un fichier son se trouvant sur le disque dur
//c'est tout juste une simplification de l'API Windows sndPlaysound
//qui s'occupe d'un transtypage de string en PAnsiChar du chemin du fichier
//un poil casse-pied dans la vision "Delphi" de la chose
procedure JouerSon(Chemin:string;flags:cardinal);

implementation

uses MMSystem; //pour le son
  { TSerpent }
//Aprs, c'est du code tout ce qu'il y a de plus classique...
function TSerpent.Add(Anneau:TAnneau): Integer;
var
  p:PTAnneau;
begin
  New(p);
  p^ := Anneau;
  result := FList.Add(p);
end;

procedure TSerpent.Clear;
var
  i:integer;
begin
  for i := 0 to FList.Count-1 do Dispose(FList[i]);
  FList.Clear;
end;

constructor TSerpent.Create;
begin
  FList := TList.Create;
end;

procedure TSerpent.Delete(Index: Integer);
begin
  Dispose(FList[Index]);
  FList.Delete(Index);
end;

destructor TSerpent.Destroy;
begin
  Clear;
  FList.Free;
  inherited;
end;

function TSerpent.GetCount: Integer;
begin
  result := FList.Count;
end;

function TSerpent.GetAnneau(Index: Integer): TAnneau;
begin
  result := PTAnneau(FList[Index])^;
end;

procedure TSerpent.Insert(Index: Integer; Anneau: TAnneau);
var
  p: PTAnneau;
begin
  New(p);
  p^ := Anneau;
  FList.Insert(Index, p);
end;

procedure TSerpent.SetCount(const Value: Integer);
var
  i, ListCount: Integer;
  p: PTAnneau;
begin
  if FList.Count = Value then
    Exit
  else
  if Value < FList.Count then
  begin
    ListCount := FList.Count;
    for i := ListCount downto Value+1 do
    begin
      FList.Delete(i);
    end;
  end else
  if FList.Count < Value then
  begin
    for i := FList.Count+1 to Value do
    begin
      New(p);
      FillChar(p^, SizeOf(TAnneau), 0);
      FList.Add(p);
    end;
  end;
end;

procedure TSerpent.SetAnneau(Index: Integer; const Value: TAnneau);
begin
  PTAnneau(FList[Index])^ := value;
end;



function TSerpent.GetDirection: TDirection;
begin
  Result:=Tete.Direction;
end;

procedure TSerpent.SetDirection(const Value: TDirection);
var LaTete:TAnneau;
begin
  LaTete:=Tete;
  // si on "active" cette ligne, on empche le serpent de revenir en arrire ;)
  //if DirectionsOpposees[Value]<>LaTete.Direction then
  LaTete.Direction:=Value;
  Tete:=LaTete;
end;

procedure TSerpent.SetQueue(const Value: TAnneau);
begin
  Anneaux[Count-1] := Value;
end;

procedure TSerpent.SetTete(const Value: TAnneau);
begin
  Anneaux[0]:=Value;
end;

function TSerpent.GetQueue: TAnneau;
begin
  if Count>0 then
  Result:=Anneaux[Count-1];
end;

function TSerpent.GetTete: TAnneau;
begin
  if Count>0 then
  Result:=Anneaux[0];
end;

//La boite de dialogue pour rentrer le high-score, inspire des InputQuery de Borland,
//mais en plus colore...
function ScoreQuery(const ACaption, APrompt: string;
  var Value: string;ABgColor,FontColor:TColor): Boolean;
var
  Form: TForm;
  Prompt: TLabel;
  Edit: TEdit;
  ButtonLeft, ButtonTop, ButtonWidth, ButtonHeight: Integer;
begin
  Result := False;
  //cration de la fiche
  Form := TForm.Create(Application); //la fiche appartient  l'application
  with Form do
    try
      Color:=ABgColor;
      Font.Name:='Lucida Console'; //La police "MS-DOS" utilise dans le jeu
                                   //(elle  l'avantage d'avoir un pas fixe,
                                   //c'est--dire que tous les caractres ont
                                   //la mme largeur
      Font.Height:=16;             //c'est la hauteur standard que je me suis
                                   //fix, elle correspond  la hauteur de mes sprites
      Font.style:=[fsbold];        //pour que a "flashe" un peu plus
      Font.Color:=FontColor;       //la couleur de la police....
      Canvas.Font := Font;         //mme police pour le canvas de la fiche,
                                   //je ne sais pas si c'tait utile d'crire a
                                   //mais bon...
      BorderStyle := bsDialog;     //on aura un look "boite de dialogue"
      Caption := ACaption;         //a, c'est le titre de la boite de dialogue
      ClientWidth :=350;           //sa largeur, obtenue avec un calcul plus ou moins empirique
                                   //en fonction de ce que j'avais  y placer dedans

      Position := poScreenCenter;  //et on l'affichera bien au centre de l'cran
                                   //pour que tout le monde la voit bien ;)

      //Cration du label qui affichera le texte invitant  crire son nom
      Prompt := TLabel.Create(Form);
      with Prompt do
      begin
        Parent := Form; //quand on cre un composant de faon dynamique
                        //il faut indiquer qui est le contrle qui va l'accueillir (ici la fiche)
                        //sinon, il ne s'affichera pas.
                        //En plus, si on dtruit la fiche (form.free),
                        //le composant sera automatiquement dtruit pour nous.
        Caption := APrompt;
        Left := 10;
        Top := 10;
        Constraints.MaxWidth :=330;
        WordWrap := True; //multiligne... (2 lignes en fait)
      end;
      //cration de la zone d'dition o l'on entre son nom de hro
      Edit := TEdit.Create(Form);
      with Edit do
      begin
        Parent := Form;
        Left := Prompt.Left+90;
        Color:=ABgColor;
        Ctl3D:=false;
        Top := Prompt.Top + Prompt.Height + 5; //Le haut du TEdit est plac en
                                               //fonction du bas du texte d'invite
        Width := 100;
        MaxLength := 10; //10 caractres maxi, a fait plus "kitch", et surtout
                         //a rentre dans mon tableau des High-Scores
                         //Vous imaginez 256 caractres ? essayez le jeu et
                         //en voyant le tableau des scores vous comprendrez cette
                         //limitation esthtique...
        Text := Value; //texte par dfaut
        SelectAll;     //le texte est slectionn pour pouvoir l'effacer
                       //d'un coup de "backspace"
      end;
      //cration d'un Tbitbtn (OK)
      //l'avantage par rapport  un TButton, c'est qu'il prendra
      //automatiquement la couleur de la fiche
      //enfin, hum, j'espre
      ButtonTop := Edit.Top; //on aligne le bouton avec la zone d'dition
      ButtonLeft:= Edit.Left+Edit.Width+5; //et on le place  droite de celle-ci
      ButtonWidth := 40; //2 carctres de large (2*16=32) avec un chouilla
                         // gauche et un chouilla  droite
      ButtonHeight := Edit.Height; //et en plus on lui donne la mme hauteur que le TEdit
      with TBitBtn.Create(Form) do
      begin
        Parent := Form;
        Caption := 'OK';
        Font.Color:=FontColor;
        ModalResult := mrOk; //renvoi un rsultat modal  la fiche (et ordonne  la fiche de
                             // se refermer)
        Default := True;  //c'est le seul bouton, et c'est le bouton "par dfaut" :
                          //si l'utilisateur appuie sur la touche "Entre",
                          //le bouton est automatiquement cliqu
        SetBounds(ButtonLeft, ButtonTop, ButtonWidth,
          ButtonHeight); //cette fonction permet de dfinir les dimmensions
                         //d'un contrle "d'un seul coup d'un seul"
      end;
      ClientHeight:=Edit.Top+Edit.Height+5; //cel permet de dfinir prcisent
               //la hauteur de la zone cliente de notre boite de dialogue
               //la zone cliente, c'est la zone dans laquelle on affiche nos controles
               //c'est  dire la fiche, moins les bordures et la zone de titre
               //il faut la faire suffisemment grande pour que tout tienne dedans

      if ShowModal = mrOk then //on affiche , et on rcupre le rsultat modal
      begin
        Value := Edit.Text; //on rcupre le nom qui  t rentr
        Result := True;
      end;
    finally
      Form.Free; //on libre la fiche (pour ses composants, c'est fait automatiquement)
    end;
end;

//Jouer un son sur le disque dur
procedure JouerSon(Chemin:string;flags:cardinal);
begin
  //bah voil, un transtypage en PAnsiChar...
  sndPlaySound(PAnsiChar(Chemin),flags);
end;

end.
